#############################################################################
##  
#W  lib/Decimal.gd                    FUtil                     Frank Lbeck 
##  
#Y  Copyright (C)  2004
##  
##  This is based on Jean Michel's GAP3 deposit decimal.g. In addition it 
##  implements a  simple interval arithmetic such  that real  cyclotomic 
##  numbers can  be compared strictly.
##  

## filters for real and complex decimal numbers
DeclareFilter("IsDecimalApproximation", IsRingElementWithInverse);
DeclareFilter("IsComplexNumber", IsRingElementWithInverse);

## attributes for such elements
MakeAttribute("Mantissa");
MakeAttribute("Precision");
MakeAttribute("Epsilon");
MakeAttribute("RealPart");
MakeAttribute("ImaginaryPart");

## for mapping other objects into these new ones
MakeOperation("DecimalApproximation");
MakeOperation("ComplexNumber");

## sum up starting terms of Exp 
MakeOperation("Exp");

## types for such elements
BindGlobal("RealApprType", MakeType(IsDecimalApproximation and
                        IsAttributeStoringRep and
                        HasMantissa and HasPrecision and HasEpsilon));
BindGlobal("ComplexType", MakeType(IsComplexNumber and
                           IsAttributeStoringRep
                           and HasRealPart and HasImaginaryPart));

## complex I
BindGlobal("I", rec(RealPart := 0, ImaginaryPart := 1));
SET_TYPE_COMOBJ(I, ComplexType);
SetName(I, "I");

## names of some functions
MakeGlobalFunction(
        "NewtonRoU",
        "NewtonSqrt",
        "SqrtDecimalApproximation"
        );

